//--------------------------------------//
// MoreBlood  2010 - Mr.Loathsome       //
// Players bleed where they take damage //
// Based on the Bleeder mutator         //
//--------------------------------------//
class MB expands Mutator config(MoreBlood);

var() config bool bRandomMode;
var() config bool bDebugMode;
var() config bool bDeathEffect;
var() config int  MaxBleeders;
var() config int  BleedTime;
var() config float SpurtLevel;
var() config float SpurtLevel2;
var BleederEffectSpawner BESinit;

var bool bInitialized, bBroadcast;

simulated function NobodyEverCallsMe()

{
	BESinit = Spawn(class'BleederEffectSpawner', , , , );

}

simulated function PostBeginPlay()
{
	if (bInitialized) return;
	else bInitialized = True;
	Level.Game.RegisterDamageMutator(Self);
	if (bRandomMode)
	{
		MaxBleeders = Rand(25) + 1;
		BleedTime = Rand(30) + MaxBleeders;
		SpurtLevel = Rand(45) + 10;
		SpurtLevel2 = Rand(80) + 25;
		SaveConfig();
	}
	log("MaxBleeders = "$MaxBleeders$"  BleedTime = "$BleedTime$"  SpurtLevel = "$SpurtLevel$"  SpurtLevel2 = "$SpurtLevel2);
	SetTimer(1.0,false);
	Super.PostBeginPlay();
}

simulated function Timer()
{
	if ( !bBroadcast )
	{
		bBroadcast = True;
		if ( Level.NetMode != NM_DedicatedServer )
			Level.Game.BroadcastMessage("MaxBleeders = "$MaxBleeders$"  BleedTime = "$BleedTime$"  SpurtLevel = "$SpurtLevel$"  SpurtLevel2 = "$SpurtLevel2);
	}
}

function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
	local BleederEffectSpawner BES;
	local class<Effects> EffS;
	local int i, j, nb;

	Super.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);

	if (ActualDamage > 0)
	{
	if ((Victim.Health - ActualDamage) <= 0 )
		{
		 if ((bDeathEffect) && (ActualDamage < 30) && (Victim.bIsPlayer))
			DeathEffect(ActualDamage, Victim);
		}
		else
		{
			nb = NumBleeders(Victim);
			if (bDebugMode)
				log(Victim$"  Health = "$Victim.health$"  defaultHealth = "$Victim.default.health$"   NumBleeders = "$nb$"   ActualDamage = "$ActualDamage);
			if ((nb < ((Victim.health / BleedTime) + 1)) && (nb < MaxBleeders))
			{
				BES = Spawn(class'BleederEffectSpawner', Victim, , HitLocation, Victim.Rotation);
				if (BES != None)
				{
					j = ActualDamage + (BleedTime * 2);
					if (Victim.health > 1000)
						j = j * 2;
					BES.InitSpawner();
					if ((Victim.IsA('ScriptedPawn')) && (ScriptedPawn(Victim).bGreenBlood))
					{
						if (ActualDamage < 25)
						{
							if (Rand(2) == 1)
								EffS = class'UTB_GBloodDrop';
							else
								EffS = class'UTB_GBloodDrop2';
							j = j * 8;
						}
						else
						if (ActualDamage < 45)
						{
							EffS = class'GreenBlob';
						}
						else
						if (ActualDamage < 65)
							EffS = class'GreenBloodPuff';
						else
							EffS = class'GreenBloodSpray';
					}
					else
					{
						if (ActualDamage < 15)
						{
							if (Rand(2) == 1)
								EffS = class'UTB_BloodDrop';
							else
								EffS = class'UTB_BloodDrop2';
							j = j * 10;
						}
						else
						if (ActualDamage < 25)
						{
							if (Rand(2) == 1)
								EffS = class'UT_BloodHit';
							else
								EffS = class'BloodSpurt';
						}
						else
						if (ActualDamage < 40)
						{
							if (Rand(2) == 1)
								EffS = class'UTB_BloodDrop';
							else
								EffS = class'BloodPuff';
						}
						else
						if (ActualDamage < 60)
						{
							EffS = class'UT_BigBloodHit';
						}
						else
							if (Rand(2) == 1)
								EffS = class'UTB_BloodDrop';
							else
								EffS = class'BloodSpray';
					}
					BES.SetSpawnProperties(0.5, j, EffS, true);
					BES = None;
				}
			}
		}
	}
}

function int NumBleeders(Pawn Other)
{
	local BleederEffectSpawner BES;
	local int nb;

	nb = 0;
	foreach Other.ChildActors(class'BleederEffectSpawner', BES)
	{
		nb++;
	}
	return nb;
}

simulated function DeathEffect(int ActualDamage, Pawn Other)
{
	local BleederEffectSpawner BES;
	local class<Effects> EffS;

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'GreenBloodSpray';
	BES.SetSpawnProperties(0.5, 2, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'GreenBloodPuff';
	BES.SetSpawnProperties(0.5, 1, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'GreenGelPuff';
	BES.SetSpawnProperties(0.5, 1, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodDrop';
	BES.SetSpawnProperties(0.5, 60, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodDrop2';
	BES.SetSpawnProperties(0.5, 40, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'BloodSpurt';
	BES.SetSpawnProperties(0.5, 10, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_GBloodDrop';
	BES.SetSpawnProperties(0.5, 3, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'BloodSpray';
	BES.SetSpawnProperties(0.5, 7, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodTrail';
	BES.SetSpawnProperties(0.5, 1, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Floor, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodTrail';
	BES.SetSpawnProperties(0.5, 1, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Floor, );
	BES.InitSpawner();
	EffS = class'UTB_BloodPool';
	BES.SetSpawnProperties(0.5, 1, EffS, true);
}

defaultproperties
{
	bRandomMode=False
	bDebugMode=False
	bDeathEffect=True
	MaxBleeders=255
	SpurtLevel=50
	SpurtLevel2=90
}
